import { defineComponent as z, ref as G, onMounted as H, resolveComponent as _, createElementBlock as v, openBlock as c, createVNode as o, withCtx as p, createCommentVNode as b, createElementVNode as S, unref as U, Fragment as j, renderList as q, createBlock as K } from "vue";
import { Plus as y, Delete as Q } from "@element-plus/icons-vue";
const W = { class: "json-schema-form" }, X = {
  key: 0,
  class: "top-button"
}, Y = { class: "schema-container" }, Z = {
  key: 0,
  class: "empty-state"
}, x = { class: "property-fields" }, N = { class: "action-buttons" }, ee = {
  key: 0,
  class: "array-items"
}, te = { class: "property-fields" }, le = {
  key: 0,
  class: "nested-schema"
}, oe = {
  key: 1,
  class: "nested-schema"
}, se = /* @__PURE__ */ z({
  name: "JsonSchemaForm",
  __name: "main",
  props: {
    modelValue: {},
    isRootLevel: { type: Boolean, default: !0 }
  },
  emits: ["update:model-value"],
  setup(h, { emit: g }) {
    const a = h, u = g, d = G({}), C = ["string", "number", "integer", "object", "array", "boolean", "null"];
    H(() => {
      d.value = Object.keys(a.modelValue.properties || {}).reduce((t, l) => (t[l] = l, t), {});
    });
    const R = (t) => {
      var l;
      return ((l = a.modelValue.required) == null ? void 0 : l.includes(t)) || !1;
    }, w = (t) => {
      var r;
      const l = { ...a.modelValue };
      let e;
      t && ((r = l.properties) != null && r[t]) ? (l.properties[t].properties || (l.properties[t].properties = {}), e = l.properties[t].properties) : (l.properties || (l.properties = {}), e = l.properties);
      const n = `property${Object.keys(e).length + 1}`;
      e[n] = {
        type: "string",
        title: ""
      }, d.value[n] = n, u("update:model-value", l);
    }, J = (t) => {
      var r;
      const l = { ...a.modelValue };
      if (!l.properties) return;
      const { [t]: e, ...n } = l.properties;
      l.properties = n, l.required = ((r = l.required) == null ? void 0 : r.filter((f) => f !== t)) || [], delete d.value[t], u("update:model-value", l);
    }, A = (t) => {
      var f;
      const l = d.value[t];
      if (t === l || l.trim() === "") {
        d.value[t] = t;
        return;
      }
      const e = { ...a.modelValue };
      if (!e.properties) return;
      const { [t]: n, ...r } = e.properties;
      e.properties = {
        ...r,
        [l]: n
      }, e.required = (f = e.required) == null ? void 0 : f.map(
        (k) => k === t ? l : k
      ), delete d.value[t], d.value[l] = l, u("update:model-value", e);
    }, I = (t, l) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [t]: {
          ...e.properties[t],
          type: l,
          ...l === "object" && { properties: {} },
          ...l === "array" && {
            items: {
              type: "string"
            }
          }
        }
      }, u("update:model-value", e));
    }, L = (t, l) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [t]: {
          ...e.properties[t],
          title: l
        }
      }, u("update:model-value", e));
    }, P = (t, l) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [t]: l
      }, u("update:model-value", e));
    }, T = (t, l) => {
      const e = { ...a.modelValue }, n = new Set(e.required || []);
      l ? n.add(t) : n.delete(t), e.required = Array.from(n), u("update:model-value", e);
    }, $ = (t, l) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [t]: {
          ...e.properties[t],
          items: {
            ...e.properties[t].items,
            type: l,
            ...l === "object" && { properties: {} }
          }
        }
      }, u("update:model-value", e));
    }, E = (t, l) => {
      const e = { ...a.modelValue };
      if (!e.properties) return;
      const n = e.properties[t];
      n.items ? n.items = {
        ...n.items,
        title: l
      } : n.items = {
        type: "string",
        title: l
      }, e.properties = {
        ...e.properties,
        [t]: n
      }, u("update:model-value", e);
    }, D = (t, l) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [t]: {
          ...e.properties[t],
          items: l
        }
      }, u("update:model-value", e));
    };
    return (t, l) => {
      const e = _("el-button"), n = _("el-input"), r = _("el-form-item"), f = _("el-checkbox"), k = _("el-option"), B = _("el-select"), F = _("JsonSchemaForm"), M = _("el-form");
      return c(), v("div", W, [
        o(M, { ref: "formRef" }, {
          default: p(() => [
            t.isRootLevel && t.modelValue.properties && Object.keys(t.modelValue.properties).length > 0 ? (c(), v("div", X, [
              o(e, {
                type: "primary",
                icon: U(y),
                circle: "",
                onClick: l[0] || (l[0] = () => w())
              }, null, 8, ["icon"])
            ])) : b("", !0),
            S("div", Y, [
              t.isRootLevel && (!t.modelValue.properties || Object.keys(t.modelValue.properties).length === 0) ? (c(), v("div", Z, [
                o(e, {
                  type: "primary",
                  icon: U(y),
                  circle: "",
                  onClick: l[1] || (l[1] = () => w())
                }, null, 8, ["icon"])
              ])) : b("", !0),
              (c(!0), v(j, null, q(t.modelValue.properties, (m, i) => {
                var O;
                return c(), v("div", {
                  key: i,
                  class: "property-row"
                }, [
                  S("div", x, [
                    o(r, { label: "属性" }, {
                      default: p(() => [
                        o(n, {
                          modelValue: d.value[i],
                          "onUpdate:modelValue": (s) => d.value[i] = s,
                          onBlur: (s) => A(i)
                        }, null, 8, ["modelValue", "onUpdate:modelValue", "onBlur"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "必填" }, {
                      default: p(() => [
                        o(f, {
                          "model-value": R(i),
                          "onUpdate:modelValue": (s) => T(i, s)
                        }, null, 8, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "类型" }, {
                      default: p(() => [
                        o(B, {
                          "model-value": m.type,
                          "onUpdate:modelValue": (s) => I(i, s)
                        }, {
                          default: p(() => [
                            (c(), v(j, null, q(C, (s) => o(k, {
                              key: s,
                              label: s,
                              value: s
                            }, null, 8, ["label", "value"])), 64))
                          ]),
                          _: 2
                        }, 1032, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "标题" }, {
                      default: p(() => [
                        o(n, {
                          "model-value": m.title,
                          "onUpdate:modelValue": (s) => L(i, s)
                        }, null, 8, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    S("div", N, [
                      o(e, {
                        type: "danger",
                        icon: U(Q),
                        circle: "",
                        onClick: (s) => J(i)
                      }, null, 8, ["icon", "onClick"]),
                      m.type === "object" ? (c(), K(e, {
                        key: 0,
                        type: "primary",
                        icon: U(y),
                        circle: "",
                        onClick: () => w(i)
                      }, null, 8, ["icon", "onClick"])) : b("", !0)
                    ])
                  ]),
                  m.type === "array" ? (c(), v("div", ee, [
                    S("div", te, [
                      o(r, { label: "数组项" }, {
                        default: p(() => [
                          o(n, {
                            value: "items",
                            disabled: ""
                          })
                        ]),
                        _: 1
                      }),
                      o(r, { label: "必填" }, {
                        default: p(() => [
                          o(f, { disabled: "" })
                        ]),
                        _: 1
                      }),
                      o(r, { label: "类型" }, {
                        default: p(() => {
                          var s;
                          return [
                            o(B, {
                              "model-value": (s = m.items) == null ? void 0 : s.type,
                              "onUpdate:modelValue": (V) => $(i, V)
                            }, {
                              default: p(() => [
                                (c(), v(j, null, q(C, (V) => o(k, {
                                  key: V,
                                  label: V,
                                  value: V
                                }, null, 8, ["label", "value"])), 64))
                              ]),
                              _: 2
                            }, 1032, ["model-value", "onUpdate:modelValue"])
                          ];
                        }),
                        _: 2
                      }, 1024),
                      o(r, { label: "标题" }, {
                        default: p(() => {
                          var s;
                          return [
                            o(n, {
                              "model-value": (s = m.items) == null ? void 0 : s.title,
                              "onUpdate:modelValue": (V) => E(i, V)
                            }, null, 8, ["model-value", "onUpdate:modelValue"])
                          ];
                        }),
                        _: 2
                      }, 1024)
                    ]),
                    ((O = m.items) == null ? void 0 : O.type) === "object" ? (c(), v("div", le, [
                      o(F, {
                        "model-value": m.items,
                        "onUpdate:modelValue": (s) => D(i, s),
                        "is-root-level": !1
                      }, null, 8, ["model-value", "onUpdate:modelValue"])
                    ])) : b("", !0)
                  ])) : b("", !0),
                  m.type === "object" ? (c(), v("div", oe, [
                    o(F, {
                      "model-value": m,
                      "onUpdate:modelValue": (s) => P(i, s),
                      "is-root-level": !1
                    }, null, 8, ["model-value", "onUpdate:modelValue"])
                  ])) : b("", !0)
                ]);
              }), 128))
            ])
          ]),
          _: 1
        }, 512)
      ]);
    };
  }
}), ne = (h, g) => {
  const a = h.__vccOpts || h;
  for (const [u, d] of g)
    a[u] = d;
  return a;
}, re = /* @__PURE__ */ ne(se, [["__scopeId", "data-v-bd499c59"]]), ue = (h) => {
  h.component("JsonSchemaForm", re);
};
export {
  re as JsonSchemaForm,
  ue as install
};
